uniform highp sampler2D  SceneColor;
uniform highp sampler2D  BlurColor;

uniform mediump vec3 BloomTintColor;

varying mediump vec2  TexCoord0;

highp vec3 DecodeRGBE8( highp vec4 rgbe )
{
	highp vec3 vDecoded;

    // Retrieve the shared exponent
	highp float fExp = rgbe.a * 255.0 - 128.0;
	
	// Multiply through the color components
	vDecoded = rgbe.rgb * exp2(fExp);
	
	return vDecoded;
}

mediump vec3 DecodeRGB16( mediump vec3 rgb )
{
	return rgb * 2.0;
}

highp vec3 ScreenBlend( highp vec3 Color1, highp vec3 Color2 )
{
	// Original:    1-(1-a)*(1-b)
	// Alternative: b + a*(1-b)
	return 1.0 - (1.0 - Color1) * (1.0 - Color2);
}

void main()
{
   	highp vec4 vColor = texture2D( SceneColor, TexCoord0 );
    highp vec4 vBloom = texture2D( BlurColor, TexCoord0 );
    
    //vColor.rgb = DecodeRGBE8( vColor );
    //vColor.rgb = DecodeRGB16( vColor.rgb );
 	
	vColor.rgb = ScreenBlend( vColor.rgb, vBloom.rgb * BloomTintColor );

	//vColor.rgb += vBloom.rgb * BloomTintColor;
	//vColor.a = vColor.a;

    gl_FragColor = vColor;
}