uniform highp sampler2D  SceneColor;

uniform highp vec2 g_avSampleOffsets[16];
uniform highp vec4 g_avSampleWeights[16];

varying mediump vec2  TexCoord0;

void main()
{
    highp vec4 vSample = vec4(0.0, 0.0, 0.0, 0.0);
    highp vec4 vColor;
    highp vec2 vSamplePosition;
    
    for( int iSample = 0; iSample < 15; iSample++ )
    {
        // Sample from adjacent points
        vSamplePosition = TexCoord0 + g_avSampleOffsets[iSample];
        vColor = texture2D(SceneColor, vSamplePosition);
        
        vSample += g_avSampleWeights[iSample]*vColor;
    }
   	
    gl_FragColor = vSample;
}