	#define half	float
	#define half2	vec2
	#define half3	vec3
	#define half4	vec4
	#define float2	vec2
	#define float3	vec3
	#define float4	vec4

	#define MulMatrix(Mtx, Vect)	(Mtx * Vect)
	#define saturate(x)				clamp(x, 0.0, 1.0)
	#define frac(x)					fract(x)
	#define lerp( A, B, Factor )	mix( A, B, Factor )

	#define texture2DBias(Texture,UV,Bias)				texture2D(Texture, UV, Bias)
	#if USE_GL_EXT_shader_texture_lod
		#define texture2DLod(Texture,UV,Lod)			texture2DLodEXT(Texture, UV.xy, Lod)
	#else
		#define texture2DLod(Texture,UV,Lod)			texture2D(Texture, UV.xy)
	#endif

	#define tex2Dlod(Texture,UVLod)						texture2DLod(Texture, UVLod.xy, UVLod.w )
	#define texDepth2Dlod(Texture,UVLod)				texture2DLod(Texture, UVLod.xy, UVLod.w )

	#define OUT_VARYING_HIGH(Type,Name,Semantics)		varying highp Type Name
	#define OUT_VARYING_MEDIUM(Type,Name,Semantics)		varying mediump Type Name
	#define OUT_VARYING_LOW(Type,Name,Semantics)		varying lowp Type Name
	#define OUT_VARYING_DEFAULT(Type,Name,Semantics)	OUT_VARYING_MEDIUM(Type,Name,Semantics)
	#define OUT_VARYING_ARRAY_DEFAULT(Type,Name,Subs,Semantics)	OUT_VARYING_DEFAULT(Type,Name[Subs],Semantics)

	#define IN_VARYING_HIGH(Type,Name,Semantics)		OUT_VARYING_HIGH(Type,Name,Semantics)
	#define IN_VARYING_MEDIUM(Type,Name,Semantics)		OUT_VARYING_MEDIUM(Type,Name,Semantics)
	#define IN_VARYING_LOW(Type,Name,Semantics)			OUT_VARYING_LOW(Type,Name,Semantics)
	#define IN_VARYING_DEFAULT(Type,Name,Semantics)		OUT_VARYING_DEFAULT(Type,Name,Semantics)
	#define IN_VARYING_ARRAY_DEFAULT(Type,Name,Subs,Semantics)	IN_VARYING_DEFAULT(Type,Name[Subs],Semantics)

	// These statements MUST not be followed by semi-colons!
	#define IN_BUILTIN(Type,Name,Semantics)
	#define OUT_BUILTIN(Type,Name,Semantics)

	#define UNIFORM(Type,Name)							uniform Type Name
	#define UNIFORM_SAMPLER2D(Name,Semantics)			UNIFORM(sampler2D,Name)
	#define UNIFORM_HIGH(Type,Name)						UNIFORM(highp Type,Name)
	#define UNIFORM_MEDIUM(Type,Name)					UNIFORM(mediump Type,Name)
	#define UNIFORM_LOW(Type,Name)						UNIFORM(lowp Type,Name)

	#define ATTRIBUTE(Type,Name,Semantics)				attribute Type Name

#define NUM_SAMPLES 4
// macros fall over with the (NUM_SAMPLES + 1)/2 stuff, so, just use a number
// 4 + 1 / 2 = 2
#define NUM_VARYINGS 2

UNIFORM(vec4, SampleOffsets4[(NUM_SAMPLES + 1) / 2]);

ATTRIBUTE(vec4, Position, POSITION);
ATTRIBUTE(vec2, TexCoords0, TEXCOORD0);

OUT_VARYING_ARRAY_DEFAULT(vec4, OffsetUVs, NUM_VARYINGS, TEXCOORD0);

void main()
{
	for(int OffsetIndex = 0;OffsetIndex < (NUM_SAMPLES + 1) / 2;OffsetIndex++)
	{
		OffsetUVs[OffsetIndex] = TexCoords0.xyyx + SampleOffsets4[OffsetIndex];
	}
	gl_Position = Position;
}
