varying lowp vec4  VertexColor;

highp vec4 EncodeRGBE8( highp vec3 rgb )
{
	highp vec4 vEncoded;

    // Determine the largest color component
	highp float maxComponent = max( max(rgb.r, rgb.g), rgb.b );
	
	// Round to the nearest integer exponent
	highp float fExp = ceil( log2(maxComponent) );

    // Divide the components by the shared exponent
	vEncoded.rgb = rgb / exp2(fExp);
	
	// Store the shared exponent in the alpha channel
	vEncoded.a = (fExp + 128.0) / 255.0;

	return vEncoded;
}

mediump vec3 EncodeRGB16( mediump vec3 rgb )
{
	return rgb / 2.0;
}

void main()
{
	gl_FragColor = vec4( EncodeRGB16(VertexColor.rgb), VertexColor.a );
}
