
attribute highp vec4	Position;

attribute highp vec4	Normal;
attribute highp vec3	Tangent;
attribute mediump float BlendWeight;

attribute highp vec2	UV;
attribute highp vec4	Color;

uniform highp mat4	WVPMat;
uniform highp vec3	CameraRight;
uniform highp vec3	CameraUp;
uniform highp vec3	EyePos;

uniform mediump mat4 SpriteCorner;
const mediump vec3 g_up = vec3(0.0,0.0,-1.0);
const mediump vec3 g_right = vec3(1.0,0.0,0.0);

varying lowp vec4		VertexColor;
varying mediump vec2	TexCoord;

void main()
{
	int nCornerId = int(Position.w);

	vec3 size = Tangent;

	highp vec4 pos = Position;

	size.y = size.z;

	float fc = cos( -BlendWeight );
	float fs = sin( -BlendWeight );

	highp vec3 right = fc * g_right + fs * g_up;
	highp vec3 up = -fs * g_right + fc * g_up;

	pos.xyz += SpriteCorner[nCornerId].x * right * size.x + SpriteCorner[nCornerId].y * up * size.y;
	pos.w = 1.0;

	gl_Position = WVPMat * pos;

	TexCoord = UV;

	VertexColor = Color;
}
