
attribute highp vec4	Position;

attribute highp vec4	Normal;
attribute highp vec3	Tangent;
attribute mediump float BlendWeight;

attribute highp vec2	UV;
attribute highp vec4	Color;

uniform highp mat4	WVPMat;
uniform highp vec3	CameraRight;
uniform highp vec3	CameraUp;
uniform highp vec3	EyePos;

uniform mediump mat4 SpriteCorner;

varying lowp vec4		VertexColor;
varying mediump vec2	TexCoord;

void main()
{
	int nCornerId = int(Position.w);

	vec3 size = Tangent;

	highp vec4 pos = Position;

	highp float Rotate = BlendWeight;

	float fc = cos( -Rotate );
	float fs = sin( -Rotate );

	highp vec3 right = fc * CameraRight + fs * CameraUp;
	highp vec3 up = -fs * CameraRight + fc * CameraUp;

	pos.xyz += SpriteCorner[nCornerId].x * right * size.x + SpriteCorner[nCornerId].y * up * size.y;
	pos.w = 1.0;

	gl_Position = WVPMat * pos;

	TexCoord = UV;

	VertexColor = Color;
}
